#include "MyLibraryClass.h"

#include <boost/archive/polymorphic_iarchive.hpp>
#include <boost/archive/polymorphic_oarchive.hpp>


//Factory function

__declspec(dllexport) IMyLibraryClass* GetMyLibraryClass()
{
	return (IMyLibraryClass*)(new MyLibraryClass());
}


//MyLibraryClass

MyLibraryClass::MyLibraryClass()
{
	m_data = 0;
}


//IMyLibraryClass

void MyLibraryClass::SetData(int data)
{
	m_data = data;
}

int MyLibraryClass::GetData()
{
	return m_data;
}


//boost::serialization

void MyLibraryClass::serialize(boost::archive::polymorphic_iarchive& ar, const unsigned int file_version)
{
	ar & m_data;
}

void MyLibraryClass::serialize(boost::archive::polymorphic_oarchive& ar, const unsigned int file_version)
{
	ar & m_data;
}


