#include "MyLibrarySerializer.h"

#include <boost/archive/polymorphic_iarchive.hpp>
#include <boost/archive/polymorphic_oarchive.hpp>
#include <boost/serialization/export.hpp>

//All concrete library classes included here
#include "MyLibraryClass.h"

//All concrete library classes exported here
BOOST_CLASS_EXPORT(MyLibraryClass);


//Factory function
MyLibrarySerializer GMyLibrarySerializer;
__declspec(dllexport) IMyLibrarySerializer* GetMyLibrarySerializer()
{
	return (IMyLibrarySerializer*)(&GMyLibrarySerializer);
}


MyLibrarySerializer::MyLibrarySerializer()
{
	const MyLibraryClass tmpMyLibraryClass;
	boost::serialization::void_cast_register(&tmpMyLibraryClass, dynamic_cast<const IMyLibraryClass*>(&tmpMyLibraryClass));
}

void MyLibrarySerializer::Serialize(boost::archive::polymorphic_iarchive& ar, IMyLibraryClass* obj)
{
	ar & obj;
}

void MyLibrarySerializer::Serialize(boost::archive::polymorphic_oarchive& ar, IMyLibraryClass* obj)
{
	ar & obj;
}
